import { OnChanges, SimpleChanges } from '@angular/core';
import { ControlValueAccessor, FormControl, ValidationErrors, Validator } from '@angular/forms';
import { CustomKeyboardEvent } from './custom-keyboard-event';
import { IConfig } from './ngx-mask.config';
import { NgxMaskService } from './ngx-mask.service';
import * as i0 from "@angular/core";
export declare class NgxMaskDirective implements ControlValueAccessor, OnChanges, Validator {
    maskExpression: string | undefined | null;
    specialCharacters: IConfig['specialCharacters'];
    patterns: IConfig['patterns'];
    prefix: IConfig['prefix'];
    suffix: IConfig['suffix'];
    thousandSeparator: IConfig['thousandSeparator'];
    decimalMarker: IConfig['decimalMarker'];
    dropSpecialCharacters: IConfig['dropSpecialCharacters'] | null;
    hiddenInput: IConfig['hiddenInput'] | null;
    showMaskTyped: IConfig['showMaskTyped'] | null;
    placeHolderCharacter: IConfig['placeHolderCharacter'] | null;
    shownMaskExpression: IConfig['shownMaskExpression'] | null;
    showTemplate: IConfig['showTemplate'] | null;
    clearIfNotMatch: IConfig['clearIfNotMatch'] | null;
    validation: IConfig['validation'] | null;
    separatorLimit: IConfig['separatorLimit'] | null;
    allowNegativeNumbers: IConfig['allowNegativeNumbers'] | null;
    leadZeroDateTime: IConfig['leadZeroDateTime'] | null;
    leadZero: IConfig['leadZero'] | null;
    triggerOnMaskChange: IConfig['triggerOnMaskChange'] | null;
    apm: IConfig['apm'] | null;
    inputTransformFn: IConfig['inputTransformFn'] | null;
    outputTransformFn: IConfig['outputTransformFn'] | null;
    keepCharacterPositions: IConfig['keepCharacterPositions'] | null;
    maskFilled: IConfig['maskFilled'];
    private _maskValue;
    private _inputValue;
    private _position;
    private _code;
    private _maskExpressionArray;
    private _justPasted;
    private _isFocused;
    /**For IME composition event */
    private _isComposing;
    private readonly document;
    _maskService: NgxMaskService;
    protected _config: IConfig;
    onChange: (_: any) => void;
    onTouch: () => void;
    ngOnChanges(changes: SimpleChanges): void;
    validate({ value }: FormControl): ValidationErrors | null;
    onPaste(): void;
    onFocus(): void;
    onModelChange(value: string | undefined | null | number): void;
    onInput(e: CustomKeyboardEvent): void;
    onCompositionStart(): void;
    onCompositionEnd(e: CustomKeyboardEvent): void;
    onBlur(e: CustomKeyboardEvent): void;
    onClick(e: MouseEvent | CustomKeyboardEvent): void;
    onKeyDown(e: CustomKeyboardEvent): void;
    /** It writes the value in the input */
    writeValue(controlValue: unknown): Promise<void>;
    registerOnChange(fn: typeof this.onChange): void;
    registerOnTouched(fn: typeof this.onTouch): void;
    private _getActiveElement;
    checkSelectionOnDeletion(el: HTMLInputElement): void;
    /** It disables the input element */
    setDisabledState(isDisabled: boolean): void;
    private _applyMask;
    private _validateTime;
    private _getActualInputLength;
    private _createValidationError;
    private _setMask;
    static ɵfac: i0.ɵɵFactoryDeclaration<NgxMaskDirective, never>;
    static ɵdir: i0.ɵɵDirectiveDeclaration<NgxMaskDirective, "input[mask], textarea[mask]", ["mask", "ngxMask"], { "maskExpression": { "alias": "mask"; "required": false; }; "specialCharacters": { "alias": "specialCharacters"; "required": false; }; "patterns": { "alias": "patterns"; "required": false; }; "prefix": { "alias": "prefix"; "required": false; }; "suffix": { "alias": "suffix"; "required": false; }; "thousandSeparator": { "alias": "thousandSeparator"; "required": false; }; "decimalMarker": { "alias": "decimalMarker"; "required": false; }; "dropSpecialCharacters": { "alias": "dropSpecialCharacters"; "required": false; }; "hiddenInput": { "alias": "hiddenInput"; "required": false; }; "showMaskTyped": { "alias": "showMaskTyped"; "required": false; }; "placeHolderCharacter": { "alias": "placeHolderCharacter"; "required": false; }; "shownMaskExpression": { "alias": "shownMaskExpression"; "required": false; }; "showTemplate": { "alias": "showTemplate"; "required": false; }; "clearIfNotMatch": { "alias": "clearIfNotMatch"; "required": false; }; "validation": { "alias": "validation"; "required": false; }; "separatorLimit": { "alias": "separatorLimit"; "required": false; }; "allowNegativeNumbers": { "alias": "allowNegativeNumbers"; "required": false; }; "leadZeroDateTime": { "alias": "leadZeroDateTime"; "required": false; }; "leadZero": { "alias": "leadZero"; "required": false; }; "triggerOnMaskChange": { "alias": "triggerOnMaskChange"; "required": false; }; "apm": { "alias": "apm"; "required": false; }; "inputTransformFn": { "alias": "inputTransformFn"; "required": false; }; "outputTransformFn": { "alias": "outputTransformFn"; "required": false; }; "keepCharacterPositions": { "alias": "keepCharacterPositions"; "required": false; }; }, { "maskFilled": "maskFilled"; }, never, never, true, never>;
}
